unit win2kf;

interface

{$IFDEF LINUX}
uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls;
{$ENDIF}

{$IFDEF WIN32}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;
{$ENDIF}


type
  TForm1 = class(TForm)
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    button1: TBUtton;
  public
    constructor Create (AOnwer: TComponent); override;
  end;

var
  Form1: TForm1;

implementation

{$IFDEF WIN32}
{$R *.DFM}
{$ENDIF}


uses
  win2kform2;

function PlainWinProc (hWnd: THandle; nMsg: UINT;
  wParam, lParam: Cardinal): Cardinal; export; stdcall;
begin
  Result := 0;
  case nMsg of
    wm_lButtonDown:
      MessageBox (hWnd, 'Mouse Clicked',
        'Plain API', MB_OK);
    wm_Destroy:
      PostQuitMessage (0);
    else
      Result := DefWindowProc (hWnd, nMsg, wParam, lParam);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
  strCaption: string;
begin
  for i := 1 to 2000 do
  begin
    strCaption := IntToStr (i);

    with TForm2.Create (Application) do
    begin
      Caption := strCaption;
      if (I mod 50) = 0 then Show;
    end;

    // common code
//    ProgressBar1.Position := I;
    Caption := 'win2k: ' + IntToStr (i);
    Application.ProcessMessages;
  end;
end;

constructor TForm1.Create(AOnwer: TComponent);
begin
  inherited;
  button1 := TBUtton.Create (self);
  button1.Parent := self;
  button1.show;
  button1.SetBounds (20, 20, 80, 80);
  button1.ONClick := Button1Click;
end;

end.
