unit noth;

interface

{$IFDEF LINUX}
uses
  Classes, QControls, QDialogs;
{$ENDIF}

{$IFDEF WIN32}
uses
  Classes, Controls, Dialogs;
{$ENDIF}


type
  TNothing = class (TGraphicControl)
  public
    constructor Create (Owner: TComponent); override;
    procedure Paint; override;
  published
    property Width default 50;
    property Height default 50;
    property Align;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
  end;

procedure Register;

implementation

constructor TNothing.Create (Owner: TComponent);
begin
  // call parent class constructor first
  inherited Create (Owner);
  // set the size
  Width := 50;
  Height := 50;

  ShowMEssage ('Nothing created');
end;

procedure TNothing.Paint;
begin

{  Canvas.Brush.Color := 1234;
  Canvas.Rectangle (10, 10, width-20, height-20);
}  

end;

procedure Register;
begin
  RegisterComponents('Fun', [TNothing]);
end;

end.
